#include "../lib/rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/bb/shutdown.c 178 2004-05-05 06:09:03Z kc $")

#include "bb.h"

void shutdown_command(char *parameter)
{
  int opt;
  char *optnames[] = {"now", "noreboot"};
  enum {now, noreboot};
  boolean opts[lengthof(optnames)];

  for(opt=0; opt<lengthof(opts); opt++) opts[opt] = FALSE;
  while(*parameter) {
    if(isopt(*parameter)) {
      char *word;
      strcpy(parameter, parameter+1);
      if((opt=match(word=getword(parameter), optnames, lengthof(opts)))!=-1) {
	opts[opt] = TRUE;
      } else {
	fprintf(stderr, "unrecognized qualifier /%s\n", word);
	return;
      }
    } else {
      fprintf(stderr, "unexpected input: '%s'\n", parameter);
      return;
    }
  }
  do_connect();
  if(client_shutdown(!opts[noreboot], opts[now])) {
    fprintf(cmdout, "Server %s %s.\n",
	    opts[noreboot] ? "shutting down" : "rebooting",
	    opts[now] ? "immediately" : "eventually");
  } else {
    fprintf(stderr, "Server shut down request failed: %s\n", client_error);
  }
}
