#include "rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/lib/block.c 860 2008-10-28 14:53:24Z kc $")

#include <signal.h>
#include <stdio.h>
#include <unistd.h>
#include "client.h"

static signal_t (*old_tstp) () = SIG_DFL;
static signal_t (*old_int) () = SIG_DFL;
static signal_t (*old_quit) () = SIG_DFL;
static int sigs = 0;

#define M_TSTP	(1 << 0)
#define M_INT	(1 << 1)
#define M_QUIT	(1 << 2)

#ifdef DEBUG
#include <stdio.h>

extern int Debug;

#define DEBUG_MISC (1 << 2)
#endif /* DEBUG */

static signal_t mark(int sig)
{
    switch (sig) {
    case SIGTSTP:
#ifdef DEBUG
	if (Debug & DEBUG_MISC)
	    fprintf(DEBUG_FILE, "Caught TSTP\n");
#endif /* DEBUG */
	if (sigs & M_TSTP) {
#ifdef DEBUG
	    if (Debug & DEBUG_MISC)
		fprintf(DEBUG_FILE, "Killing server connection.\n");
#endif /* DEBUG */
	    server_close();
	}
	sigs |= M_TSTP;
	break;
    case SIGINT:
#ifdef DEBUG
	if (Debug & DEBUG_MISC)
	    fprintf(DEBUG_FILE, "Caught INT\n");
#endif /* DEBUG */
	if (sigs & M_INT) {
#ifdef DEBUG
	    if (Debug & DEBUG_MISC)
		fprintf(DEBUG_FILE, "Killing server connection.\n");
#endif /* DEBUG */
	    server_close();
	}
	sigs |= M_INT;
	break;
    case SIGQUIT:
#ifdef DEBUG
	if (Debug & DEBUG_MISC)
	    fprintf(DEBUG_FILE, "Caught QUIT\n");
#endif /* DEBUG */
	sigs |= M_QUIT;
	server_close();
	break;
    }
    signal(sig, mark);
}

void block()
{
    signal_t (*old) ();

    if ((old = signal(SIGTSTP, mark)) != mark)
	old_tstp = old;
    if ((old = signal(SIGINT, mark)) != mark)
	old_int = old;
    if ((old = signal(SIGQUIT, mark)) != mark)
	old_quit = old;
}

void unblock()
{
         signal(SIGTSTP, old_tstp);
    signal(SIGINT, old_int);
    signal(SIGQUIT, old_quit);
    if (sigs) {
	int tsignals = sigs;

	sigs = 0;

	if (tsignals & M_TSTP) {
#ifdef DEBUG
	    if (Debug & DEBUG_MISC)
		fprintf(DEBUG_FILE, "Doing TSTP\n");
#endif /* DEBUG */
	    kill(getpid(), SIGTSTP);
	}
	if (tsignals & M_INT) {
#ifdef DEBUG
	    if (Debug & DEBUG_MISC)
		fprintf(DEBUG_FILE, "Doing INT\n");
#endif /* DEBUG */
	    kill(getpid(), SIGINT);
	}
	if (tsignals & M_QUIT) {
#ifdef DEBUG
	    if (Debug & DEBUG_MISC)
		fprintf(DEBUG_FILE, "Doing QUIT\n");
#endif /* DEBUG */
	    kill(getpid(), SIGQUIT);
	}
    }
}
