#include "../rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/lib/client/changeroom.c 178 2004-05-05 06:09:03Z kc $")

#include "header.h"

int client_changeroom(const char *room, const char *owner,
		      const time_t *default_expiration,
		      const class_t *default_class, const char *summary_line,
		      const bb_priority *priority, const bb_archive_t *archive)
{
    int                 code;
    directory_info     *room_info = NULL;

    room_info = client_roominfo(room);
    if (!room_info)
	return 0;

    block();

    write_server_code(CLIENT_CHANGEROOM);
    write_socket_string(server_socket, room);

    if (owner)
	write_socket_string(server_socket, owner);
    else
	write_socket_string(server_socket, room_info->owner);

    if (default_expiration)
	write_socket_int(server_socket, *default_expiration);
    else
	write_socket_int(server_socket, -1);

    if (default_class)
	write_socket_int(server_socket, *default_class);
    else
	write_socket_int(server_socket, -1);

    if (summary_line)
	write_socket_string(server_socket, summary_line);
    else
	write_socket_string(server_socket, room_info->summary);

    if (priority)
	if (*priority >= 0)
	    write_socket_int(server_socket, *priority + 1);
	else
	    write_socket_int(server_socket, *priority);
    else
	write_socket_int(server_socket, 0);

    if (archive)
	write_socket_int(server_socket, (int) *archive);
    else
	write_socket_int(server_socket, -1);

    read_server_code(&code);
    unblock();
    return code == SERVER_ACK;
}
