#include "../server/server.h"

#define final_message_number reserved

summary_list *get_dbm_summary(bb_rid room);

main(int argc, char *argv[])
{
  directory_entry room_info;
  bb_rid room;
  summary_list *summary;

  setlinebuf(stdout);
  setlinebuf(stderr);
  if(!chdir(argv[1])) {
    perror(argv[1]);
    return 1;
  }
  alt_database_init(TRUE);
  chdir(MESSAGEBASE);
  database_init(FALSE);
  for(room=0; room <= Last_rid; room++) {
    if(!get_directory_entry(&room_info, room)) continue;
    if(!(summary = get_summary(room))) {
      fprintf(stderr, "\nError retrieving summary for %s (%d)\n",
	      room_info.name, room);
      continue;
    }
    if(summary->count <= 0 &&
       room_info.first_message_number < room_info.final_message_number) {
      printf("Missing %s (%d). . .\n", room_info.name, room);
      printf("\tChecking dbm. . . ", room_info.name, room); fflush(stdout);
      dump_cache();
      summary = get_dbm_summary(room);
      if(summary->count <= 0) {
	printf(" still no help!\n");
      } else {
	printf(" Whew!\n");
	if(!put_summary(room)) {
	  fprintf(stderr, "\nError storing summary for %s (%d)\n",
		  room_info.name, room);
	  continue;
	}
      }
    }
    dump_cache();
  }
  database_shutdown();
  return 0;
}

