#include "../server/config.h"
#include "../server/server.h"
#include <ndbm.h>

int max_active_slot;
struct client_struct client[MAX_CLIENTS];

extern DBM *user;
char *classes[4] = {"no_access","read_only","read_write","moderator"};

main(argc,argv)
     int argc;
     char *argv[];
{
  datum key;
  room_user_entry *room_user_info;
  directory_entry *room_info;
  char id[ID_SIZE];
  char room[ROOM_SIZE];

  chdir(MESSAGEBASE);
  database_init();
  strcpy(room,argv[1]);
  room_info = get_directory_entry(room);
  if(!room_info) {
    perror("error retrieving room information");
    return;
  }
  setlinebuf(stdout);
  for (key = dbm_firstkey(user);
       key.dptr != NULL;
       key = dbm_nextkey(user)) {
    bzero(id,sizeof(id));
    bcopy(key.dptr,id,key.dsize);
    room_user_info = get_room_user_entry(room,id);
    if(room_user_info) {
      if((room_user_info->class != room_info->default_class) ||
	 room_user_info->last_message_read) {
	printf("user '%s' %d %d %s\n",
	       id,
	       room_user_info->last_message_read,
	       room_user_info->hidden,
	       classes[room_user_info->class]);
      }
    } else printf("(user '%s')\n",id);
  }
  database_shutdown();
}
