#include "../server/server.h"

main(int argc, char *argv[])
{
    group_entry group_info;
    bb_gid gid;

    setlinebuf(stdout);
    setlinebuf(stderr);
    chdir(MESSAGEBASE);
    if(!database_init(FALSE, TRUE)) {
	perror("database init failed");
	return 1;
    }

    strcpy(group_info.name, "supported");
    group_info.owner = OWNER_UID;
    group_info.default_class = read_only;
    group_info.group_offset = 0;
    group_info.max_expiration = 1*365*86400;

    gid = add_gid(group_info.name);
    if (!put_group_entry(gid, &group_info))
	perror("put_group_entry");


    strcpy(group_info.name, "inhouse");
    group_info.owner = OWNER_UID;
    group_info.default_class = read_only;
    group_info.group_offset = 0;
    group_info.max_expiration = 1*365*86400;

    gid = add_gid(group_info.name);
    if (!put_group_entry(gid, &group_info))
	perror("put_group_entry");


    strcpy(group_info.name, "software");
    group_info.owner = OWNER_UID;
    group_info.default_class = read_only;
    group_info.group_offset = 0;
    group_info.max_expiration = 10*365*86400;

    gid = add_gid(group_info.name);
    if (!put_group_entry(gid, &group_info))
	perror("put_group_entry");


    strcpy(group_info.name, "bbb");
    group_info.owner = get_uid("skyhawk");
    group_info.default_class = read_only;
    group_info.group_offset = 0;
    group_info.max_expiration = 90*86400;

    gid = add_gid(group_info.name);
    if (!put_group_entry(gid, &group_info))
	perror("put_group_entry");


    strcpy(group_info.name, "libraries");
    group_info.owner = get_uid("reynolds");
    group_info.default_class = read_only;
    group_info.group_offset = 0;
    group_info.max_expiration = 2*365*86400;

    gid = add_gid(group_info.name);
    if (!put_group_entry(gid, &group_info))
	perror("put_group_entry");


    database_shutdown();
    return 0;
}
