#include "../server/server.h"

int main(int argc, char *argv[])
{
    DbUser userinfo;
    char id[ID_SIZE];
    char passwd[10], saltc[2];
    time_t salt;
    int c, j;
    bb_uid uid;

    if (--argc != 2) {
	printf("format: %s <user> <password>\n", argv[0]);
	return 0;
    }
    strcpy(id, argv[1]);
    strcpy(passwd, argv[2]);
    chdir(MESSAGEBASE);
    if (!database_init(FALSE, TRUE)) {
	perror("database init failed");
	return 1;
    }
    uid = get_uid(id);
    if (uid < 0) {
	printf("user '%s' not found\n", id);
	database_shutdown();
	return 0;
    }
    if (!get_db_user(&userinfo, uid) ||
	strcmp(userinfo.id, id) != 0) {
	printf("user '%s' (%d) not in user file (possible db corruption?)\n",
		id, (int)uid);
	return 0;
    }
    time(&salt);
    saltc[0] = salt & 077;
    saltc[1] = (salt >> 6) & 077;
    for (j = 0; j < 2; j++) {
	c = saltc[j] + '.';
	if (c > '9')
	    c += 7;
	if (c > 'Z')
	    c += 6;
	saltc[j] = c;
    }
    bzero(userinfo.passwd, sizeof(userinfo.passwd));
    strcpy(userinfo.passwd, (char *)crypt(passwd, saltc));
    if (put_db_user(uid, &userinfo)) {
	printf("bb password for <%s> (%d) set to '%s'.\n",
	       userinfo.id, uid, passwd);
    } else {
	printf("unable to reset bb password for <%s> (%d)\n", id, uid);
    }
    database_shutdown();
    return 0;
}
