#ifndef DEBUG
#define DEBUG
#endif /* DEBUG */
#include "../server/config.h"
#include "../server/server.h"
#include <ndbm.h>
#include <stdio.h>
#include <sys/time.h>

int max_active_slot;
struct client_struct client[MAX_CLIENTS];

char *message_summary(int number, message_entry *entry, boolean full,
		      int width);

main(argc, argv)
     int argc;
     char *argv[];
{
  int message;
  message_entry *message_info;
  directory_entry *room_info;
  char room[ROOM_SIZE];
  bb_rid rid;
  struct timeval before, after, delta;

  chdir(MESSAGEBASE);
  database_init();
  bzero(room, sizeof(room));
  strcpy(room, argv[1]);
  rid = get_rid(room);
  room_info = get_directory_entry(rid);
  if(!room_info) {
    perror("error retrieving room information");
    return;
  }
  setlinebuf(stdout);
  gettimeofday(&before, 0);
  for(message = room_info->first_message_number;
      message <= room_info->next_message_number-1;
      message++)
    if(message_info = get_message_entry(rid, message)) {
    }
  gettimeofday(&after, 0);
  database_shutdown();
  delta.tv_sec = after.tv_sec - before.tv_sec;
  delta.tv_usec = after.tv_usec - before.tv_usec;
  if(delta.tv_usec < 0) {
    delta.tv_usec += 1000000;
    delta.tv_sec -= 1;
  }
  printf("%d%07.3f = ", delta.tv_sec, delta.tv_usec/1000.0);
  printf("%d%07.3f - ", after.tv_sec, after.tv_usec/1000.0);
  printf("%d%07.3f\n", before.tv_sec, before.tv_usec/1000.0);
}

char *Date(time_t date)
{
  char *d;

  d = ctime(&date);
  *(d+24) = '\0';
  return d;
}

char *message_summary(int number, message_entry *entry, boolean full,
		      int width)
{
  static char line[BUFFER_SIZE];

  if(full) {
    sprintf(line, "%c %4d %12.12s %4d [%10.10s] %s",
	    entry->deleted ? '*' : ' ',
	    number,
	    Date(entry->date)+4,
	    entry->lines,
	    entry->poster_id,
	    entry->subject);
  } else {
    sprintf(line, "(%12.12s) %4d [%10.10s] %s",
	    Date(entry->date)+4,
	    entry->lines,
	    entry->poster_id,
	    entry->subject);
  }
  line[width-1] = '\0';
  return line;
}
