#include "../lib/rcsid.h"

RCS_ID("$Header: svn+ssh://kcase.org/Source/svn/kcase/tags/bb/2.6/server/protocol.c 178 2004-05-05 06:09:03Z kc $")

#include "server.h"
#include "../lib/misc.h"

void server_protocol(int i)
{
    read_socket_int(Client[i].socket, &Client[i].major_version);
    read_socket_int(Client[i].socket, &Client[i].minor_version);
    if (Client[i].major_version != PROTOCOL_MAJOR) {
	char err_text[BUFFER_SIZE];

	sprintf(err_text,
		"incompatible protocols\n\tclient: %d.%d\n\tserver: %d.%d",
		Client[i].major_version, Client[i].minor_version,
		PROTOCOL_MAJOR, PROTOCOL_MINOR);
	write_socket_code(Client[i].socket, SERVER_ERR);
	write_socket_string(Client[i].socket, err_text);
	close_client(i);
	return;
    }
    write_socket_code(Client[i].socket, SERVER_ACK);
    if (Client[i].minor_version >= 1) {
	write_socket_int(Client[i].socket, PROTOCOL_MAJOR);
	write_socket_int(Client[i].socket, PROTOCOL_MINOR);
    }
}
